- Main Page
- Modules
- Namespaces
- Classes
- Files
- Related Pages

- File List
- File Members

# FUtils/FUString.h File Reference

This file includes FUStringBuilder.h and FUStringConversion.h and defines important string-related macros and inline functions. More...

`#include "FUtils/FUStringBuilder.h"`
`#include "FUtils/FUStringConversion.h"`
`#include "FMath/FMArray.h"`

Go to the source code of this file.

## Namespaces
namespace | fm
## Classes
class | fm::stringT< CH >
| A string template. More...
## Defines
#define | FS(a) fstring(FC(a))
| A Unicode string from a constant 8-bit string.
#define | TO_FSTRING(a) FUStringConversion::ToFString(a)
| A Unicode string from any convertable value: string, vector-type or simple numeric.
#define | TO_STRING(a) FUStringConversion::ToString(a)
| An 8-bit string from any convertable value: Unicode string, vector-type or simple numeric.
## Typedefs
typedef stringT< char > | fm::string
| A string of UTF8 characters.
typedef fm::stringT< fchar > | fstring
| A string of UNICODE characters.
typedef fm::vector< fstring > | FStringList
| A dynamically-sized array of Unicode strings.
typedef fm::vector< fm::string > | StringList
| A dynamically-sized array of simple strings.
## Functions
template<class CharT>
stringT< CharT > | fm::operator+ (const stringT< CharT > &A, const stringT< CharT > &B)
| Concatenates two strings.
template<class CharT>
stringT< CharT > | fm::operator+ (const CharT *A, const stringT< CharT > &B)
| See above.
template<class CharT>
stringT< CharT > | fm::operator+ (const stringT< CharT > &A, const CharT *B)
| See above.
template<class CharT>
stringT< CharT > & | fm::operator+= (stringT< CharT > &A, const stringT< CharT > &B)
| See above.
template<class CharT>
stringT< CharT > & | fm::operator+= (stringT< CharT > &A, const CharT *B)
| See above.
template<class CharT>
stringT< CharT > & | fm::operator+= (stringT< CharT > &A, const CharT &B)
| Appends a character to a string.
template<class CharT>
bool | fm::operator< (const stringT< CharT > &A, const stringT< CharT > &B)
| Retrieves whether a first string is lesser than a second string.
template<class CharT>
bool | fm::operator== (const stringT< CharT > &A, const stringT< CharT > &B)
| Retrieves whether a first string is equal to a second string.
template<class CharT>
bool | fm::operator!= (const stringT< CharT > &A, const stringT< CharT > &B)
| Retrieves whether a first string differs from a second string.
template<class CharT>
bool | fm::operator!= (const stringT< CharT > &A, const CharT *B)
| Retrieves whether a first string differs from a second string.
bool | IsEquivalent (const char *sz1, const char *sz2)
| Returns whether two 8-bit strings are equivalent.
bool | IsEquivalent (const fm::string &sz1, const char *sz2)
| See above.
bool | IsEquivalent (const char *sz1, const fm::string &sz2)
| See above.
bool | IsEquivalent (const fm::string &sz1, const fm::string &sz2)
| See above.
bool | IsEquivalentI (const char *sz1, const char *sz2)
| Returns whether two 8-bit strings are equivalent.
bool | IsEquivalentI (const fm::string &sz1, const char *sz2)
| See above.
bool | IsEquivalentI (const char *sz1, const fm::string &sz2)
| See above.
bool | IsEquivalentI (const fm::string &sz1, const fm::string &sz2)
| See above.
bool | IsEquivalentI (const fchar *sz1, const fchar *sz2)
| See above.
bool | IsEquivalentI (const fstring &sz1, const fchar *sz2)
| See above.
bool | IsEquivalentI (const fchar *sz1, const fstring &sz2)
| See above.
bool | IsEquivalentI (const fstring &sz1, const fstring &sz2)
| See above.
bool | operator== (const fm::string &sz1, const char *sz2)
| Returns whether two 8-bit strings are equivalent.
bool | IsEquivalent (const fchar *sz1, const fchar *sz2)
| Returns whether two Unicode strings are equivalent.
bool | IsEquivalent (const fstring &sz1, const fchar *sz2)
| See above.
bool | IsEquivalent (const fchar *sz1, const fstring &sz2)
| See above.
bool | IsEquivalent (const fstring &sz1, const fstring &sz2)
| See above.
bool | operator== (const fstring &sz1, const fchar *sz2)
| Returns whether two Unicode strings are equivalent.
bool | IsEquivalent (FUSStringBuilder &builder, const char *sz)
| Returns whether a string builder and a string are equivalent.
bool | IsEquivalent (FUSStringBuilder &builder, const fm::string &sz)
| See above.
bool | IsEquivalent (FUStringBuilder &builder, const fchar *sz)
| See above.
bool | IsEquivalent (FUStringBuilder &builder, const fstring &sz)
| See above.
## Variables
FCOLLADA_EXPORT const char * | emptyCharString
| An empty UTF-8 string.
FCOLLADA_EXPORT const fchar * | emptyFCharString
| An empty Unicode string.
FCOLLADA_EXPORT const fm::string | emptyString
| An empty UTF-8 string.
FCOLLADA_EXPORT const fstring | emptyFString
| An empty Unicode string.

## Detailed Description

This file includes FUStringBuilder.h and FUStringConversion.h and defines important string-related macros and inline functions.

## Function Documentation

bool IsEquivalent | ( | FUSStringBuilder & | builder,
|  | const char * | sz
| ) | `[inline]`

  | Returns whether a string builder and a string are equivalent. This is a case-sensitive comparison. Parameters:
  | builder | The string builder to compare.
  | sz | The string to compare.
Returns: Whether the two strings are equivalent.

bool IsEquivalent | ( | const fchar * | sz1,
|  | const fchar * | sz2
| ) | `[inline]`

  | Returns whether two Unicode strings are equivalent. This is a case-sensitive comparison. Parameters:
  | sz1 | The first Unicode string to compare.
  | sz2 | The second Unicode string to compare.
Returns: Whether the two Unicode strings are equivalent.

bool IsEquivalent | ( | const char * | sz1,
|  | const char * | sz2
| ) | `[inline]`

  | Returns whether two 8-bit strings are equivalent. This is a case-sensitive comparison. Parameters:
  | sz1 | The first 8-bit string to compare.
  | sz2 | The second 8-bit string to compare.
Returns: Whether the two 8-bit strings are equivalent.

bool IsEquivalentI | ( | const char * | sz1,
|  | const char * | sz2
| ) | `[inline]`

  | Returns whether two 8-bit strings are equivalent. This is a case-insensitive comparison. Parameters:
  | sz1 | The first 8-bit string to compare.
  | sz2 | The second 8-bit string to compare.
Returns: Whether the two 8-bit strings are equivalent.

bool operator== | ( | const fstring & | sz1,
|  | const fchar * | sz2
| ) | `[inline]`

  | Returns whether two Unicode strings are equivalent. This is a case-sensitive comparison. Parameters:
  | sz1 | The first Unicode string to compare.
  | sz2 | The second Unicode string to compare.
Returns: Whether the two Unicode strings are equivalent.

bool operator== | ( | const fm::string & | sz1,
|  | const char * | sz2
| ) | `[inline]`

  | Returns whether two 8-bit strings are equivalent. This is a case-sensitive comparison. Parameters:
  | sz1 | The first 8-bit string to compare.
  | sz2 | The second 8-bit string to compare.
Returns: Whether the two 8-bit strings are equivalent.

## Variable Documentation

FCOLLADA_EXPORT const char* emptyCharString

| An empty UTF-8 string. This string is returned in many functions when there is an error.

FCOLLADA_EXPORT const fchar* emptyFCharString

| An empty Unicode string. This string is returned in many functions when there is an error.

FCOLLADA_EXPORT const fstring emptyFString

| An empty Unicode string. This string is returned in many functions when there is an error.

FCOLLADA_EXPORT const fm::string emptyString

| An empty UTF-8 string. This string is returned in many functions when there is an error.